<?php

namespace App\Exceptions;

use Illuminate\Foundation\Exceptions\Handler as ExceptionHandler;
use Throwable;

class Handler extends ExceptionHandler
{
    /**
     * The list of the inputs that are never flashed to the session on validation exceptions.
     *
     * @var array<int, string>
     */
    protected $dontFlash = [
        'current_password',
        'password',
        'password_confirmation',
    ];

    /**
     * Register the exception handling callbacks for the application.
     */
    public function register(): void
    {
        $this->reportable(function (Throwable $e) {
            //
        });
    }

    // function render($request, Throwable $exception)
    // {
    //     if ($exception->getMessage() === "This action is unauthorized.") {
    //         return response()->view('admin.errors.403', [], 403);
    //     }

    //     if ($this->isHttpException($exception)) {
    //         if ($exception->getStatusCode() == 404) {
    //             return response()->view('admin.errors.404', [], 404);
    //         }
    //         if ($exception->getStatusCode() == 500) {
    //             return response()->view('admin.errors.500', [], 500);
    //         }
    //     }
    //     return parent::render($request, $exception);
    // }

    public function render($request, Throwable $exception)
    {
        $isAdminRoute = $request->is('tgn-admin/*');

        if ($exception->getMessage() === "This action is unauthorized.") {
            return response()->view($isAdminRoute ? 'admin.errors.403' : 'site.errors.403', ['absoluteHeader' => true], 403);
        }

        if ($this->isHttpException($exception)) {
            if ($exception->getStatusCode() == 404) {
                return response()->view($isAdminRoute ? 'admin.errors.404' : 'site.errors.404', ['absoluteHeader' => true], 404);
            }
            if ($exception->getStatusCode() == 500) {
                return response()->view($isAdminRoute ? 'admin.errors.500' : 'site.errors.500', ['absoluteHeader' => true], 500);
            }
        }

        return parent::render($request, $exception);
    }
}
